'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.googleApis = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _es6Promisify = require('es6-promisify');

var _es6Promisify2 = _interopRequireDefault(_es6Promisify);

var _googleapis = require('googleapis');

var _googleapis2 = _interopRequireDefault(_googleapis);

var _parseDuration = require('parse-duration');

var _parseDuration2 = _interopRequireDefault(_parseDuration);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * MIT License
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Copyright (c) 2017 Choko (choko@curioswitch.org)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Permission is hereby granted, free of charge, to any person obtaining a copy
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * of this software and associated documentation files (the "Software"), to deal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * in the Software without restriction, including without limitation the rights
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * copies of the Software, and to permit persons to whom the Software is
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * furnished to do so, subject to the following conditions:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * The above copyright notice and this permission notice shall be included in all
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * copies or substantial portions of the Software.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * SOFTWARE.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

class GoogleApis {
  constructor() {
    this.projectId = null;
    this.cancelBuild = null;
    this.createBuild = null;
    this.listBuilds = null;
    this.createKmsKeyring = null;
    this.createKmsKey = null;
    this.decryptKms = null;
    this.encryptKms = null;
    this.setKmsIamPolicy = null;
  }

  getProjectId() {
    var _this = this;

    return _asyncToGenerator(function* () {
      yield _this.init();

      if (!_this.projectId) {
        throw new Error('Not initialized.');
      }
      return _this.projectId;
    })();
  }

  createKeyring(location, keyring) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      yield _this2.init();

      if (!_this2.projectId) {
        throw new Error('Not initialized.');
      }
      const request = {
        parent: `projects/${_this2.projectId}/locations/${location}`,
        keyRingId: keyring
      };
      if (!_this2.createKmsKeyring) {
        throw new Error('Not initialized.');
      }
      const created = yield _this2.createKmsKeyring(request);
      console.log(`Keyring ${created.name} created.`);
    })();
  }

  createKey(location, keyring, key) {
    var _this3 = this;

    return _asyncToGenerator(function* () {
      yield _this3.init();

      if (!_this3.projectId) {
        throw new Error('Not initialized.');
      }
      const request = {
        parent: `projects/${_this3.projectId}/locations/${location}/keyRings/${keyring}`,
        cryptoKeyId: key,
        resource: {
          purpose: 'ENCRYPT_DECRYPT'
        }
      };
      if (!_this3.createKmsKey) {
        throw new Error('Not initialized.');
      }
      const created = yield _this3.createKmsKey(request);
      console.log(`Key ${created.name} created.`);
    })();
  }

  decryptKey(location, keyring, key, encryptedBase64) {
    var _this4 = this;

    return _asyncToGenerator(function* () {
      yield _this4.init();

      if (!_this4.projectId) {
        throw new Error('Not initialized.');
      }

      const request = {
        name: `projects/${_this4.projectId}/locations/${location}/keyRings/${keyring}/cryptoKeys/${key}`,
        resource: {
          ciphertext: encryptedBase64
        }
      };

      if (!_this4.decryptKms) {
        throw new Error('Not initialized.');
      }
      const { plaintext } = yield _this4.decryptKms(request);
      return plaintext;
    })();
  }

  encryptKey(location, keyring, key, plaintext) {
    var _this5 = this;

    return _asyncToGenerator(function* () {
      yield _this5.init();

      if (!_this5.projectId) {
        throw new Error('Not initialized.');
      }

      const request = {
        name: `projects/${_this5.projectId}/locations/${location}/keyRings/${keyring}/cryptoKeys/${key}`,
        resource: {
          plaintext: Buffer.from(plaintext).toString('base64')
        }
      };

      if (!_this5.encryptKms) {
        throw new Error('Not initialized.');
      }
      const { ciphertext } = yield _this5.encryptKms(request);
      return ciphertext;
    })();
  }

  setDecrypter(location, keyring, serviceAccount) {
    var _this6 = this;

    return _asyncToGenerator(function* () {
      yield _this6.init();

      if (!_this6.projectId) {
        throw new Error('Not initialized.');
      }

      const request = {
        resource_: `projects/${_this6.projectId}/locations/${location}/keyRings/${keyring}`,
        resource: {
          policy: {
            bindings: [{
              role: 'roles/cloudkms.cryptoKeyDecrypter',
              members: [`serviceAccount:${serviceAccount}`]
            }]
          }
        }
      };
      if (!_this6.setKmsIamPolicy) {
        throw new Error('Not initialized.');
      }
      yield _this6.setKmsIamPolicy(request);
    })();
  }

  cancelCloudbuild(id) {
    var _this7 = this;

    return _asyncToGenerator(function* () {
      yield _this7.init();

      if (!_this7.projectId) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const request = {
        projectId: _this7.projectId,
        id
      };
      if (!_this7.cancelBuild) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      return _this7.cancelBuild(request);
    })();
  }

  listCloudbuilds(filter) {
    var _this8 = this;

    return _asyncToGenerator(function* () {
      yield _this8.init();

      if (!_this8.projectId) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const request = {
        projectId: _this8.projectId,
        filter
      };
      if (!_this8.listBuilds) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const { builds } = yield _this8.listBuilds(request);
      return builds || [];
    })();
  }

  startCloudbuild(cloudbuildConfig, substitutions, tags) {
    var _this9 = this;

    return _asyncToGenerator(function* () {
      yield _this9.init();

      if (!_this9.projectId) {
        throw new Error('Not initialized, this is a programming bug.');
      }

      const sanitizedConfig = cloudbuildConfig.timeout ? _extends({}, cloudbuildConfig, {
        timeout: `${(0, _parseDuration2.default)(cloudbuildConfig.timeout) / 1000}s`
      }) : cloudbuildConfig;
      const request = {
        projectId: _this9.projectId,
        resource: _extends({}, sanitizedConfig, {
          options: {
            substitutionOption: 'ALLOW_LOOSE'
          },
          substitutions,
          tags
        })
      };

      console.log('Creating build job.');
      if (!_this9.createBuild) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const response = yield _this9.createBuild(request);
      console.log(response);
      return response;
    })();
  }

  init() {
    var _this10 = this;

    return _asyncToGenerator(function* () {
      if (_this10.projectId) {
        return;
      }

      const { auth, projectId } = yield _this10.authorize();
      _this10.projectId = projectId;
      const cloudkms = _googleapis2.default.cloudkms({ version: 'v1', auth });
      _this10.createKmsKeyring = (0, _es6Promisify2.default)(cloudkms.projects.locations.keyRings.create, cloudkms);
      _this10.createKmsKey = (0, _es6Promisify2.default)(cloudkms.projects.locations.keyRings.cryptoKeys.create, cloudkms);
      _this10.decryptKms = (0, _es6Promisify2.default)(cloudkms.projects.locations.keyRings.cryptoKeys.decrypt, cloudkms);
      _this10.encryptKms = (0, _es6Promisify2.default)(cloudkms.projects.locations.keyRings.cryptoKeys.encrypt, cloudkms);
      _this10.setKmsIamPolicy = (0, _es6Promisify2.default)(cloudkms.projects.locations.keyRings.cryptoKeys.setIamPolicy, cloudkms);

      const cloudbuild = _googleapis2.default.cloudbuild({ version: 'v1', auth });
      _this10.cancelBuild = (0, _es6Promisify2.default)(cloudbuild.projects.builds.cancel, cloudbuild);
      _this10.createBuild = (0, _es6Promisify2.default)(cloudbuild.projects.builds.create, cloudbuild);
      _this10.listBuilds = (0, _es6Promisify2.default)(cloudbuild.projects.builds.list, cloudbuild);
    })();
  }

  authorize() {
    return _asyncToGenerator(function* () {
      return new Promise(function (resolve, reject) {
        return _googleapis2.default.auth.getApplicationDefault(function (err, authClient, projectId) {
          if (err) {
            reject(err);
            return;
          }
          resolve({
            auth: authClient,
            projectId
          });
        });
      });
    })();
  }
}

const googleApis = exports.googleApis = new GoogleApis();