'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.keyManager = undefined;

var _gcloud = require('./gcloud');

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * MIT License
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Copyright (c) 2017 Choko (choko@curioswitch.org)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Permission is hereby granted, free of charge, to any person obtaining a copy
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * of this software and associated documentation files (the "Software"), to deal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * in the Software without restriction, including without limitation the rights
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * copies of the Software, and to permit persons to whom the Software is
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * furnished to do so, subject to the following conditions:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * The above copyright notice and this permission notice shall be included in all
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * copies or substantial portions of the Software.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * SOFTWARE.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

class KeyManager {
  constructor() {
    this.decryptedKeys = new Map();
  }

  getGithubToken(repo) {
    var _this = this;

    return _asyncToGenerator(function* () {
      return _this.getDecrypted(_config2.default.repos[repo].encryptedGithubToken, `GITHUB_TOKEN-${repo}`);
    })();
  }

  getWebhookSecret() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      return _this2.getDecrypted(_config2.default.encryptedWebhookSecret, 'WEBHOOK_SECRET');
    })();
  }

  getDecrypted(encryptedBase64, cacheKey) {
    var _this3 = this;

    return _asyncToGenerator(function* () {
      const cached = _this3.decryptedKeys.get(cacheKey);
      if (cached) {
        return cached;
      }
      console.log('Decrypting ', cacheKey);
      const decrypted = Buffer.from((yield _gcloud.googleApis.decryptKey(_config2.default.kms.location, _config2.default.kms.keyring, _config2.default.kms.key, encryptedBase64)), 'base64').toString('ascii');
      _this3.decryptedKeys.set(cacheKey, decrypted);
      return decrypted;
    })();
  }
}

const keyManager = exports.keyManager = new KeyManager();